#include <iostream>
#include <vector>

using namespace std;
using pii = pair<int, int>;
using ll = long long;

const int MAXN = 20001, MAXK = 100001;
int N, M, K, foodcnt[MAXN];
vector<pii> ing[MAXN];
ll ingcnt[MAXK];

int main() {
    ios::sync_with_stdio(false);
    cin >> N >> M >> K;
    for (int i = 1; i <= N; ++i) {
        int a;
        cin >> a;
        for (int j = 0; j < a; ++j) {
            int k, x;
            cin >> k >> x;
            ing[i].push_back({k, x});
        }
    }
    for (int i = 1; i <= M ; ++i) {
        int b; cin >> b;
        for (int j = 0; j < b; ++j) {
            int n, y;
            cin >> n >> y;
            foodcnt[n] += y;
        }
    }
    for (int i = 1; i <= N; ++i) {
        if (foodcnt[i] == 0)
            continue;
        for (auto& [k, x] : ing[i])
            ingcnt[k] += 1ll * x * foodcnt[i];
    }
    for (int k = 1; k <= K; ++k)
        cout << ingcnt[k] << (k < K ? " " : "\n");

    return 0;
}
