using System;
using System.Collections.Generic;

namespace Bizonyitas {

    class Program {
        struct Query {
            public int t;
            public int x;
            public int y;
        }

        static int N, Q;
        static Query[] q;
        static int[,] d; 
        static string line;
        static string[] tokens;

        static void Main(string[] args) {
            line = Console.ReadLine();
            tokens = line.Split(' ');

            N = int.Parse(tokens[0]);
            Q = int.Parse(tokens[1]);

            q = new Query[Q];
            d = new int[N + 1, N + 1];

            for(int i = 1; i <= N; ++i) {
                for(int j = 1; j <= N; ++j) {
                    d[i, j] = Q + 1;
                }
            }
            
            for(int i = 0; i < Q; ++i) {
                line = Console.ReadLine();
                tokens = line.Split(' ');

                q[i].t = int.Parse(tokens[0]);
                q[i].x = int.Parse(tokens[1]);
                q[i].y = int.Parse(tokens[2]);

                if(q[i].t == 1) {
                    d[q[i].x, q[i].y] = i + 1;
                }
            }

            for(int k = 1; k <= N; ++k) {
                for(int i = 1; i <= N; ++i) {
                    for(int j = 1; j <= N; ++j) {
                        int a = Math.Max(d[i, k], d[k, j]);
                        d[i, j] = Math.Min(d[i, j], a);
                    }
                }
            }

            for(int i = 0; i < Q; ++i) {
                if(q[i].t == 2) {
                    if(d[q[i].x, q[i].y] <= i + 1) {
                        Console.WriteLine("IGEN");
                    }
                    else {
                        Console.WriteLine("NEM");
                    }
                }
            }
        }
    }
}