using System;
using System.Collections.Generic;

class Csucs
{
    public int id;
    public List<Csucs> hova = new List<Csucs>();
    public bool ki;
    public int J;

    public bool NoveloUt(Csucs cel, int J)
    {
        if (this.J == J)
            return false;
        if (this == cel)
            return true;
        this.J = J;
        foreach (Csucs cs in hova)
        {
            if (cs.NoveloUt(cel, J))
            {
                hova.Remove(cs);
                cs.hova.Add(this);
                return true;
            }
        }
        return false;
    }
}

static class Program
{
    static Csucs Lepes(Csucs kezdo)
    {
        const int J = 1;
        var szint = kezdo.hova;
        while (szint.Count > 1)
        {
            var szint2 = new List<Csucs>();
            foreach (Csucs cs in szint)
            {
                foreach (Csucs cs2 in cs.hova)
                {
                    if (cs2.J == J)
                        continue;
                    cs2.J = J;
                    szint2.Add(cs2);
                }
            }
            szint = szint2;
        }
        return szint[0];
    }

    static List<int> EgyUt(Csucs kezdo, Csucs veg)
    {
        var ut = new List<int>();
        while (veg != kezdo)
        {
            if (!veg.ki)
            {
                ut.Add(veg.id);
            }
            foreach (Csucs cs in veg.hova)
            {
                if ((cs.id == veg.id) == veg.ki)
                {
                    veg = cs;
                    break;
                }
            }
        }
        ut.Reverse();
        return ut;
    }

    static List<List<int>> KetUt(Csucs kezdo, Csucs veg)
    {
        kezdo.NoveloUt(veg, 2);
        kezdo.NoveloUt(veg, 3);
        var e = new List<List<int>>();
        foreach (Csucs cs2 in veg.hova)
        {
            if (cs2.id == veg.id)
                continue;
            Csucs cs3 = cs2;
            e.Add(EgyUt(kezdo, cs3));
        }
        return e;
    }

    static void Main()
    {
        string[] s0 = Console.ReadLine().Split();
        int N = int.Parse(s0[0]), M = int.Parse(s0[1]);
        var ki = new Csucs[N];
        var be = new Csucs[N];
        var kezdo2 = new bool[N];
        for (int i = 0; i < N; i++)
        {
            kezdo2[i] = true;
            ki[i] = new Csucs { id = i + 1, ki = true };
            be[i] = new Csucs { id = i + 1 };
            be[i].hova.Add(ki[i]);
        }
        for (int i = 0; i < M; i++)
        {
            string[] s1 = Console.ReadLine().Split();
            int U = int.Parse(s1[0]), V = int.Parse(s1[1]);
            ki[U - 1].hova.Add(be[V - 1]);
            kezdo2[V - 1] = false;
        }
        var kezdo = new Csucs { id = -1, ki = true };
        var veg = new Csucs { id = 0 };
        for (int i = 0; i < N; i++)
        {
            if (kezdo2[i])
            {
                kezdo.hova.Add(be[i]);
            }
            if (ki[i].hova.Count == 0)
            {
                ki[i].hova.Add(veg);
            }
        }
        var e1 = new List<int>();
        var e2 = new List<int>();
        var db = 1;
        while (true)
        {
            db++;
            Csucs cs;
            if (kezdo.hova.Count == 1)
            {
                cs = kezdo.hova[0];
            }
            else
            {
                cs = Lepes(kezdo);
                var utak = KetUt(kezdo, cs);
                e1.AddRange(utak[0]);
                e2.AddRange(utak[1]);
            }
            e1.Add(cs.id);
            e2.Add(cs.id);
            if (cs == veg)
                break;
            kezdo = cs.hova[0];
        }
        Console.WriteLine(2 * e1.Count - db);
        Console.WriteLine(string.Join(" ", e1));
        Console.WriteLine(string.Join(" ", e2));
    }
}