#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 100001;
int N, A[MAXN], C[MAXN], pref[MAXN];

int main() {
    ios::sync_with_stdio(false);
    cin >> N;
    for (int i = 0; i < 2 * N - 1; ++i) {
        if (i % 2 == 0)
            cin >> A[i / 2];
        else {
            char c;
            cin >> c;
            if (c == 'J') {
                C[(i + 1) / 2] = 1;
                pref[(i + 1) / 2] = pref[i / 2] + 1;
            }
            else {
                C[(i + 1) / 2] = -1;
                pref[(i + 1) / 2] = pref[i / 2] - 1;
            }
        }
    }
    int mn = 0, fst = 0, lst = 0;
    for (int i = 0; i < N; ++i) {
        if (pref[i] < mn) {
            mn = pref[i];
            fst = lst = i;
        }
        else if (pref[i] == mn)
            lst = i;
    }
    
    int ans = max(A[fst], A[lst]);
    int pos = (ans == A[fst] ? fst : lst);
    cout << ans << endl;

    int pr = -1, sl = -1;
    for (int i = 1; i < N; ++i) {
        if (i < pos && C[i] > 0)
            pr = i;
        if (i > pos && C[i] < 0 && sl == -1)
            sl = i;
    }
    if (fst != lst) {
        if (pos == fst) {
            cout << 2 * sl << endl;
        }
        else {
            cout << 2 * pr << endl;
        }
    }
    else {
        if (sl >= 0)
            cout << 2 * sl << endl;
        else if (pr >= 0)
            cout << 2 * pr << endl;
        else
            cout << 2 << endl;
    }

    return 0;
}
