using System;
using System.Linq;

struct Alapanyag
{
    public int id;
    public int db;
}

static class Program
{
    static Alapanyag[][] Beolvas(int N)
    {
        var e = new Alapanyag[N][];
        for (int i = 0; i < N; i++)
        {
            int db = int.Parse(Console.ReadLine());
            e[i] = new Alapanyag[db];
            for (int j = 0; j < db; j++)
            {
                string[] s = Console.ReadLine().Split();
                e[i][j] = new Alapanyag { id = int.Parse(s[0]) - 1, db = int.Parse(s[1]) };
            }
        }
        return e;
    }

    static void Main()
    {
        int[] s0 = Console.ReadLine().Split().Select(int.Parse).ToArray();
        int N = s0[0], M = s0[1], K = s0[2];
        var A = Beolvas(N);
        var B = Beolvas(M);
        var etel = new long[N];
        foreach (var r in B)
        {
            foreach (var a in r)
            {
                etel[a.id] += a.db;
            }
        }
        var e = new long[K];
        for (int i = 0; i < N; i++)
        {
            foreach (var a in A[i])
            {
                e[a.id] += etel[i] * a.db;
            }
        }
        Console.WriteLine(string.Join(" ", e));
    }
}