#include <iostream>
#include <vector>

using namespace std;

struct Query {
    int t, x, y;
};

int N, Q;
vector<Query> q;
vector<vector<int> > d;

int main() {
    cin >> N >> Q;
    q.assign(Q, {0, 0, 0});
    d.assign(N + 1, vector<int> (N + 1, Q + 1));
    for(int i = 0; i < Q; ++i) {
        cin >> q[i].t >> q[i].x >> q[i].y;
        if(q[i].t == 1) {
            d[q[i].x][q[i].y] = i + 1;
        }
    }

    for(int k = 1; k <= N; ++k) {
        for(int i = 1; i <= N; ++i) {
            for(int j = 1; j <= N; ++j) {
                int a = max(d[i][k], d[k][j]);
                d[i][j] = min(d[i][j], a);
            }
        }
    }

    for(int i = 0; i < Q; ++i) {
        if(q[i].t == 2) {
            cout << (d[q[i].x][q[i].y] <= i + 1 ? "IGEN\n" : "NEM\n");
        }
    }
    return 0;
}