def main():
    N, Q = map(int, input().split(' '))
    queries = []
    d = [[Q + 10] * N for _ in range(N)]
    for i in range(Q):
        t, a, b = map(int, input().split(' '))
        a -= 1
        b -= 1
        if t == 1:
            d[a][b] = min(d[a][b], i)
        else:
            queries.append((i, a, b))

    for k in range(N):
        dk = d[k]
        for i in range(N):
            di = d[i]
            for j in range(N):
                di[j] = min(di[j], max(di[k], dk[j]))

    ans = []
    for i, a, b in queries:   
        if d[a][b] <= i:
            ans.append("IGEN")
        else:
            ans.append("NEM")

    print('\n'.join(ans))

main()
