#include <iostream>
#include <vector>
#include <stack>

#define maxN 100001

using namespace std ;

int N, M, K, h, hova;
vector<int> E[maxN];
vector<pair<int,int>> Ki;

int main () {
   ios_base::sync_with_stdio(false); cin.tie(0);
   cin >> N >> M >> K;
   vector<int> E[N + 1];

   for (int i = 0; i < M; i++) {
      cin >> h;
      E[h].push_back(i + 1);
   }
   stack<int> Jo;
   int mego = 0;
   for (int x = N; x > 0; x--) {
      for (int e : E[x])
         Jo.push(e);

      for (int i = 0; i < K; i++) {
         if (Jo.size() == 0) break;
         Ki.push_back({ Jo.top(), x });
         Jo.pop();
      }
   }
   cout << Ki.size() << endl;
   for (auto xy : Ki)
      cout << xy.first << " " << xy.second << endl;

   return 0;
}
